"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const classnames_1 = __importDefault(require("classnames"));
const highlight_js_1 = __importDefault(require("highlight.js"));
const React = __importStar(require("react"));
const react_markdown_1 = __importDefault(require("react-markdown"));
require("./hljs.less");
require("./index.less");
require("./markdown.less");
highlight_js_1.default.configure({
    classPrefix: '',
    tabReplace: '  ',
});
class PreviewMarkdown extends React.Component {
    constructor(props) {
        super(props);
        this.allowNode = (node) => {
            if (node.type === 'html' && node.value) {
                if (/<!--([^]+?)-->/.test(node.value)) {
                    return false;
                }
            }
            return true;
        };
        this.state = {
            value: props.value,
        };
    }
    componentDidMount() {
        this.highlight();
    }
    highlight() {
        const code = this.node.getElementsByTagName('code');
        for (const value of code) {
            const tag = value.parentNode;
            if (tag && tag.tagName === 'PRE') {
                highlight_js_1.default.highlightBlock(value);
            }
        }
    }
    updateSource(value) {
        this.setState({ value }, () => {
            this.highlight();
        });
    }
    render() {
        const _a = this.props, { prefixCls, visble, value } = _a, elementProps = __rest(_a, ["prefixCls", "visble", "value"]);
        return (React.createElement("div", Object.assign({ ref: (node) => this.node = node, className: classnames_1.default(`${prefixCls}-preview`, {
                [`${prefixCls}-visble`]: visble
            }) }, elementProps),
            React.createElement(react_markdown_1.default, { className: classnames_1.default(`${prefixCls}-markdown`), source: this.state.value, escapeHtml: false, allowNode: this.allowNode })));
    }
}
PreviewMarkdown.defaultProps = {
    prefixCls: 'md-editor',
    visble: true,
};
exports.default = PreviewMarkdown;
