"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const bar_1 = __importDefault(require("../Icon/bar"));
require("./index.less");
class ToolBar extends React.PureComponent {
    render() {
        const _a = this.props, { prefixCls, className, onClick, toolbars } = _a, htmlProps = __rest(_a, ["prefixCls", "className", "onClick", "toolbars"]);
        return (React.createElement("div", Object.assign({ className: classnames_1.default(`${prefixCls}-toolbar`, className) }, htmlProps), toolbars.map((name, key) => {
            const Icon = bar_1.default[name];
            return (React.createElement("button", { key: key, onClick: onClick.bind(this, name) },
                " ",
                Icon,
                " "));
        })));
    }
}
ToolBar.displayName = 'ToolBar';
ToolBar.defaultProps = {
    onClick: () => null,
    prefixCls: 'md-editor',
    toolbars: ['bold', 'italic', 'header', 'strike', 'underline', 'olist', 'ulist', 'todo', 'link', 'image', 'quote', 'preview'],
};
exports.default = ToolBar;
